#include "camack.c"

#define INPUT_REGISTER  1
#define INPUT_REG_RF    0
#define INPUT_REG_RA    0
#define INPUT_REG_CF    9
#define INPUT_REG_CA    0

#define ADC             2
#define ADC_RF          0
#define ADC_CF          9
#define ADC_CA          0

#define SCALER          4
#define SCALER_RF       0
#define SCALER_CF       9
#define SCALER_CA       0

#define OUTPUT_REGISTER 5
#define OUTPUT_REG_F    17
#define OUTPUT_REG_A    0

#define LAM_N           ADC
#define LAM_F           26
#define LAM_A           12

static long loop=0,data;
static int stat;

static void dc_int_init(),dc_int_start(),dc_int_stop(),dc_int_clear();

static void dc_int_init()
{
  camac_NAF(SCALER,SCALER_CA,SCALER_CF);
  dc_int_start();
}

static void dc_int_start()
{
  camac_write24(0x0000f0);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,OUTPUT_REG_F);
  dc_int_clear();
/*  camac_NAF(LAM_N,LAM_A,LAM_F);*/
}

static void dc_int_stop()
{
  camac_NAF(LAM_N,LAM_A,24);
  camac_write24(0x000f00);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,OUTPUT_REG_F);
}

static void dc_int_clear()
{
  camac_NAF(ADC,ADC_CA,ADC_CF);
  camac_NAF(ADC,ADC_CA,10);
  camac_NAF(INPUT_REGISTER,INPUT_REG_CA,INPUT_REG_CF);
  camac_write24(0x00000f);
  camac_NAF(OUTPUT_REGISTER,OUTPUT_REG_A,OUTPUT_REG_F);
}
/*
static void dc_int(int irq, struct pt_regs *regs) 
*/

static int dc_int(unsigned short buffer[])
{
  static long j; 
  void cleanup_module();

  loop++;
  j=inl(BASE_ADDRESS+4);
  if(j==0){
    printk("dc_int: interrupt %d occured, %d, LAM=%lx\n",IRQ,loop,j);
/*    if(loop>10) cleanup_module();*/
    if(dc_int_flag==0)outl(0,BASE_ADDRESS);
    else outl(0,BASE_ADDRESS);
    /* reset interrupt from crate controller*/
    return(-1);
  }
/*  printk("dc_int: interrupt %d occured, %d, LAM=%lx\n",IRQ,loop,j);*/
  buffer[0]=8;
  camac_NAF(INPUT_REGISTER,INPUT_REG_RA,INPUT_REG_RF);
  buffer[1]=camac_read16();
  camac_NAF(ADC,0,ADC_RF);
  buffer[2]=camac_read16();
  camac_NAF(ADC,1,ADC_RF);
  buffer[3]=camac_read16();
  camac_NAF(ADC,2,ADC_RF);
  buffer[4]=camac_read16();
  camac_NAF(ADC,3,ADC_RF);
  buffer[5]=camac_read16();
  camac_NAF(SCALER,0,SCALER_RF);
  j=camac_read24();
  buffer[6]=j&0xffff;
  buffer[7]=(j>>16)&0xffff;
  return(0);
}

